﻿using AspectCore.DynamicProxy;
using Microsoft.Extensions.Logging;

namespace HealthMonitor.Core.Pipeline.Aop
{
    public class CacheInterceptorContext
    {
        /// <summary>
        /// Aop上下文
        /// </summary>
        public AspectContext AopContext { get; set; } = default!;
        /// <summary>
        /// Aop管道阀门
        /// </summary>
        public AspectDelegate AopDelegate { get; set; } = default!;
        /// <summary>
        /// 日志
        /// </summary>
        public ILogger Logger { get; set; } = default!;
        /// <summary>
        /// 被代理方法的返回类型
        /// </summary>
        public Type ReturnType { get; set; } = default!;
        /// <summary>
        /// 被代理方法的引用的实体类型
        /// </summary>
        public Type EntityType { get; set; } = default!;
        /// <summary>
        /// 被代理方法是否返回列表
        /// </summary>
        public bool IsReturnEnumerable { get; set; } = default!;
        /// <summary>
        /// 被代理方法是否为异步方法
        /// </summary>
        public bool IsAsyncMethod { get; set; } = default!;
        /// <summary>
        /// 服务请求关联标识
        /// </summary>
        public string RequestId { get; set; } = default!;   
    }
}
